; dispnum.s
;
; Demo display routine(s).
;
; Mark J. Sebern
; MSOE
; 12 April 1994 (updated 13 December 1998)
;

        .globl  div10  ; Declare external routine.

; Define some symbols for port addresses and constants.

        .area   ABS (ABS)

pioc    =     0x1002   ; Port control register
portb   =     0x1004   ; Port B
ddrc    =     0x1007   ; Data direction register C
portc   =     0x1003   ; Port C

; Set location counter for "ROM" code area.

        .area   ROMCODE (REL,CON)

; disp8 - Subroutine to display 8-bit signed number.
;
; Inputs:
;       A - Number to display.
;
; Outputs:
;       All registers are preserved.
;
; Function:
;       Displays the 8-bit number in the form "-ddd" on the alphanumeric
;       display. A positive sign is displayed as a blank; leading zeros
;       are not blanked.
;       Assumes that port C has been set up properly.
;
disp8::
	psha            ; Save registers.
	pshb

	ldab    #3      ; Address leftmost character.
	stab    portc

	ldab    #'      ; Assume positive number (blank sign character).
	tsta            ; Is it positive?
	bge     disp8a  ; If GE, yes.
	nega            ; No, make it positive (unsigned).
	ldab    #'-     ; Set sign character to "-".
disp8a:
	stab    portb   ; Display the sign character.
	
	jsr     div10   ; Divide the number by 10.
	clr     portc   ; Address rightmost character.
	addb    #'0     ; Convert 1's digit (remainder) to ASCII.
	stab    portb   ; Display 1's digit.
	
	jsr     div10   ; Divide remaining number by 10.
	inc     portc   ; Address 10's digit character.
	addb    #'0     ; Convert 10's digit to ASCII.
	stab    portb   ; Display 10's digit.
	
	inc     portc   ; Address 100's digit.
	adda    #'0     ; Convert 100's digit to ASCII.
	staa    portb   ; Display 100's digit.

	pulb            ; Restore registers.
	pula

	rts             ; Return to caller.

